/*
 * Copyright (C) 2013 Philippe Komma
 * 
 * This file is part of Number: A Number Detection and 
 * Classification Framework
 * 
 * Number is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Foobar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __BLOBS_H__
#define __BLOBS_H__

#include <vector>

#include <opencv2/opencv.hpp>

#include "Classifier.h"
#include "PointStack.h"

class Blobs
{
  public:
    
    struct Blob
    {
      int x;
      int y;
      int w;
      int h;
      int dist;
      int area;
      int label;  
      int number;
    };
    
    static void extract( std::vector<Blob>& blobs, IplImage* imgBinary, int imgW, int imgH, unsigned char* visited, unsigned int* labelBuffer, PointStack* pointStack );
    
    static void classify( std::vector<Blob>& blobs, Classifier& classifier, unsigned int* labelBuffer, int widthStep );
};


#endif