/*
 * Copyright (C) 2013 Philippe Komma
 * 
 * This file is part of Number: A Number Detection and 
 * Classification Framework
 * 
 * Number is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Foobar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __CLASSIFIER_H__
#define __CLASSIFIER_H__

class Classifier
{
  public:
    
    struct Number
    {
      unsigned int   value;
      unsigned char* data;
    };
    
    Classifier();
    
    Classifier( const char* fname );
    
    ~Classifier();
    
    bool init( const char* fname );
    
    bool load( const char* fname );
    
    void release();
    
    void classify( unsigned int label, unsigned int* labelBuffer, int widthStep, int x1, int y1, int x2, int y2, int& number, int& dist );
    
  protected:
    
    Number** m_number;
    
    unsigned char* m_scaled;
    
    unsigned char* m_bitCount;
    
    int linspace( int a, int b, int n, int idx );

    void scalePattern( unsigned int label, unsigned int* labelBuffer, int widthStep, int x1, int y1, int x2, int y2 );
    
    unsigned int calcDist( unsigned char* ref, unsigned char* cmp );
};

#endif