/*
 * Copyright (C) 2013 Philippe Komma
 * 
 * This file is part of Number: A Number Detection and 
 * Classification Framework
 * 
 * Number is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Foobar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar. If not, see <http://www.gnu.org/licenses/>.
 */

#include "Font.h"

Font::Font()
{
	m_font = new CvFont;

    cvInitFont( m_font, CV_FONT_HERSHEY_DUPLEX, 0.5, 0.5, 0, 1, CV_AA );
}

Font::~Font()
{
	delete m_font;
}

int Font::ShowText( std::string text, int type, int pos_x, int pos_y, IplImage* img )
{
	cvPutText( img, text.c_str(), cvPoint( pos_x, pos_y ), m_font, cvScalar( 255, 0, 0, 0 ) );

	return 0;
}
