/*
 * Copyright (C) 2013 Philippe Komma
 * 
 * This file is part of Number: A Number Detection and 
 * Classification Framework
 * 
 * Number is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Foobar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __NUMBER_DEMO_H__
#define __NUMBER_DEMO_H__

#include <vector>

#include <opencv2/opencv.hpp>

#include "Program.h"

#include "Font.h"
#include "Blobs.h"
#include "Classifier.h"
#include "PointStack.h"
#include "AdaptiveThreshold.h"

class NumberDemo : public Program
{
	public:

		NumberDemo();

		IplImage* exec( IplImage* img );

	protected:

		int m_imgW;

		int m_imgH;

		Font* m_font;

		IplImage* m_imgBinary;

		IplImage* m_imgLabels;

		unsigned int* m_labelBuffer;
	
		unsigned long* m_integralImg;
	
		unsigned char* m_visited;		
	
		PointStack* m_pointStack;
	
		Classifier* m_classifier;

		std::vector<Blobs::Blob> m_blobs;

		void renderRectangle( IplImage* screen, int x1, int y1, int x2, int y2, int r, int g, int b );

		void renderBlobs( IplImage* screen, std::vector<Blobs::Blob>& blobs, Font* font );

		void mapColors( IplImage* dst, unsigned int* src, int w, int h );
};

#endif